/*
* BearLibMap
* Copyright (C) 2013 Cfyz
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
* IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef BEARLIBMAP_H
#define BEARLIBMAP_H

#ifdef _WIN32
#  ifdef BEARLIBMAP_LIBRARY
#    define MAP_API __declspec(dllexport)
#  else
#    define MAP_API __declspec(dllimport)
#  endif
#else
#  define MAP_API
#endif

#ifdef __cplusplus
extern "C" {
#endif

MAP_API int map_alloc(int width, int height, const char* description);
MAP_API void map_free(int map_id);
MAP_API int map_copy(int map_id);
MAP_API int map_assign(int dst_map_id, int src_map_id);
MAP_API void map_clear(int map_id);
MAP_API void map_clear_layer(int map_id, int layer);
MAP_API void map_set(int map_id, int x, int y, int layer, int value);
MAP_API void map_setf(int map_id, int x, int y, int layer, float value);
MAP_API int map_get(int map_id, int x, int y, int layer);
MAP_API float map_getf(int map_id, int x, int y, int layer);
MAP_API int map_width(int map_id);
MAP_API int map_height(int map_id);

#undef MAP_API

#ifdef __cplusplus
} // End of extern "C"
#endif

#endif // BEARLIBMAP_H
