/*
 * main.cpp
 *
 *  Created on: Feb 19, 2013
 *      Author: Cfyz
 */

/*
#include "../../bearlibterminal/Interface/bearlibterminal.h"

int main()
{
	terminal_open(0);
	terminal_options("input.events=keypress; title=ABC def");
	terminal_put(1, 1, '@');
	terminal_get_nonblocked(5000);
	terminal_close();
	return 0;
}
*/


#include "BearLibTerminal.h"
#include "Demos.hpp"

#include <Windows.h>
#include <functional>

int CALLBACK WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	terminal_open(CODEPAGE_DEFAULT);

	struct demo
	{
		const char* name;
		std::function<void()> func;
	}
	demos[] =
	{
		{"Basic output", BasicOutput},
		{"Fonts", BasicFontViewer},
		{"Codepages", Codepages},
		{"Speed", Speed},
		{"Flare", Flare},
		{"Keyboard", Keyboard},
		{"Mouse", Mouse},
		{"Sprites", Sprites}
	};

	const int N_demos = sizeof(demos)/sizeof(demos[0]);

	auto setup_default = [&]()
	{
		terminal_options("size=80x25; font.name=default; title=BearLibTerminal demo: menu; input.events=keypress");
		terminal_options("icon=media\\icon.ico;");
		terminal_color(COLOR_WHITE);
		terminal_bkcolor(COLOR_BLACK);
	};

	setup_default();

	int counter = 0;
	bool proceed = true;

	do
	{
		terminal_clear();
		terminal_color(0xFFFFFFFF);
		int i = 0;
		for ( ; i < N_demos; i++ )
		{
			terminal_printf(1, 1+i, "%d. %s", i+1, demos[i].name);
		}
		terminal_printf(1, 1+i+0, "ESC. Exit");
		terminal_printf(1, 1+i+2, "Your choice?");

		terminal_color(0xFF404040);
		terminal_printf(0, 24, "%d", counter);

		terminal_refresh();

		do
		{
			int code = terminal_get();
			counter += 1;

			if ( code == VK_CLOSE || code == VK_ESCAPE )
			{
				proceed = false;
				break;
			}
			else if ( code >= '1' && code < ('1' + N_demos) )
			{
				demos[code-'1'].func();
				setup_default();
			}
		}
		while ( terminal_has_input() );
	}
	while ( proceed );

	terminal_close();

	return 0;
}
